//----------------------------------------------------------------------------
// C
//
// FILENAME: time_slot.c
// VERSION: Rev A
//----------------------------------------------------------------------------
//************************************************************************
// EXTERNAL DEFINITIONS
//************************************************************************
//;-------------------------------------------------------------------
//; Declare the functions global for both assembler and C compiler.
//;
//; Note that there are two names for each API. First name is
//; assembler reference. Name with underscore is name refence for
//; C compiler. Calling function in C source code does not require
//; the underscore.
//;-------------------------------------------------------------------
#include "m8c.h"
#include "stdlib.h"
#include "Time_Slot.h"
#pragma interrupt_handler Process_Time_Slot_Counter ;

//definimos procedimientosm que se van a ejecutar en diferentes tiempos
// tambien se definen en main.c


extern void teclado_16_teclas(void);
extern void conversor_dual_13_bits(void);
extern void TX_com_serial_9600_baudios(void);
extern void voz(void);
extern void lcd(void);

//--------------------------------------

//--------------------------------------
int Slice_Counter = 0 ;
int Time_Slot_Counter = 0;
extern int Slice_Counter ;
extern int Time_Slot_Counter;

//-------------------------------------------------------------------
// Process_Time_Slot_Counter()
// Time_Slot_Counter will Reflect any Slice_Counter bits that
// have changed.
// To ensure only one Task runs at each time 1 is added.
// Note; This Function is being called by the RTOS_Timer8INT
//
//-------------------------------------------------------------------
void Process_Time_Slot_Counter (void)// rutina de interrupcion del timer RTOS
{int RTOS_Temp ; // Local
RTOS_Temp = Slice_Counter++;
Time_Slot_Counter |= ((RTOS_Temp ^ Slice_Counter) + 1);//'^' XOR bitabít ,'~' NOT bit a bit
//---------------------------------------------------------------
// Only to toggle the LED
// In a other Applications this operation could be removed
//---------------------------------------------------------------
//PRT0DR ^= 0x20 ;// Only to toggle the LED  ^es XOR
}
//-------------------------------------------------------------------
// This Task will run every 1 ms o 125us con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period

//TIME_SLOT_COUNTER_BIT_02 2 4 4000 1
//-------------------------------------------------------------------
void Time_Slot_02(void)  //duracion leyendo un vector de la palabra 17.6us con F=32KHz no de 4Khz(se divio el timer por 1 no por 8)
{
   voz();
}
//-------------------------------------------------------------------
// This Task will run every 2 ms o 250us con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_03 3 8 4000 2
//-------------------------------------------------------------------
void Time_Slot_03(void)
{

}
//-------------------------------------------------------------------
// This Task will run every 4 ms o 500us con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_04 4 16 4000 4
//-------------------------------------------------------------------
void Time_Slot_04(void)
{

}
//-------------------------------------------------------------------
// This Task will run every 8 ms o 1ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_05 5 32 4000 8
//-------------------------------------------------------------------
void Time_Slot_05(void)
{

}
//-------------------------------------------------------------------
// This Task will run every 16 ms o 2ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_06 6 64 4000 16
//-------------------------------------------------------------------
void Time_Slot_06(void)
{

}
//-------------------------------------------------------------------
// This Task will run every 32 ms o 4ms con RTOS de 32Khz
//// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_07 7 128 4000 32
//-------------------------------------------------------------------
void Time_Slot_07(void)
{

}
//-------------------------------------------------------------------
// This Task will run every 64 ms o 8ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_08 8 256 4000 64
//-------------------------------------------------------------------
void Time_Slot_08(void)													
{

}
//-------------------------------------------------------------------
// This Task will run every 128 ms o 16ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_09 9 512 4000 128
//-------------------------------------------------------------------
void Time_Slot_09(void)
{

//PRT2DR ^= 0x02 ;// Only to toggle the LED
}
//-------------------------------------------------------------------
// This Task will run every 256 ms o 32ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_10 10 1024 4000 256
//-------------------------------------------------------------------
void Time_Slot_10(void)
{
  
}
//-------------------------------------------------------------------
// This Task will run every 512 ms o 64ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_11 11 2048 4000 512
//-------------------------------------------------------------------
void Time_Slot_11(void)// duracion 544us
{

teclado_16_teclas();//lee tecla cada 64ms

}
//-------------------------------------------------------------------
// This Task will run every 1024 ms o 128ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
///TIME_SLOT_COUNTER_BIT_12 12 4096 4000 1024
//-------------------------------------------------------------------
void Time_Slot_12(void) //duaracion 6.8ms
{
//PRT2DR ^= 0x08 ;// Only to toggle the LED colocar  el puerto P23 en Strong
//conversor_dual_13_bits();

}
//-------------------------------------------------------------------
// This Task will run every 2048 ms o 256ms con RTOS de 32Khz
//// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_13 13 8192 4000 2048
//-------------------------------------------------------------------
void Time_Slot_13(void)
{
//PRT2DR ^= 0x04 ;// Only to toggle the LED colocar  el puerto P22 en Strong
lcd();
}
//-------------------------------------------------------------------
// This Task will run every 4096 ms o 512ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_14 14 16384 4000 4096
//-------------------------------------------------------------------
void Time_Slot_14(void) //duracion 10ms
{
//PRT2DR ^= 0x02 ;// Only to toggle the LED colocar  el puerto P21 en Strong	
//TX_com_serial_9600_baudios(); 
 
}
//-------------------------------------------------------------------
// This Task will run every 8192 ms o 1024ms con RTOS de 32Khz
//
// Bit Rate [Hz] Time Slot Period [ms]
//TIME_SLOT_COUNTER_BIT_15 15 32768 4000 8192
//-------------------------------------------------------------------
void Time_Slot_15(void)
{
	
	//	PRT2DR ^= 0x01 ;// Only to toggle the LED colocar  el puerto P20 en Strong
	// en este ejemplo en cada pasada por el correspondiente slot se prende o se apaga por eso los tiempos parecen dobles 
}