;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   DUALADC_1.inc
;;  Version: 2.30, Updated on 2012/3/2 at 9:14:34
;;  Generated by PSoC Designer 5.2.2551
;;
;;  DESCRIPTION:  Assembler declarations for the DualADC User Module.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2012. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************



;--------------------------------------------------
; Constants for DUALADC_1 API's.
;--------------------------------------------------

; Counter1 Constants
DUALADC_1_bfCounter1_Mask:             equ   10h
DUALADC_1_bfCounter1_INT_REG:          equ   0e1h

; Counter2 Constants
DUALADC_1_bfCounter2_Mask:             equ   80h
DUALADC_1_bfCounter2_INT_REG:          equ   0e1h

; PWM Constants
DUALADC_1_bfPWM16_Mask:                equ   40h
DUALADC_1_bfPWM16_INT_REG:             equ   0e1h

; Power Settings
DUALADC_1_bfPOWERMASK:                 equ   03h
DUALADC_1_OFF:                         equ   00h
DUALADC_1_LOWPOWER:                    equ   01h
DUALADC_1_MEDPOWER:                    equ   02h
DUALADC_1_HIGHPOWER:                   equ   03h

; Parameter Settings
DUALADC_1_bNUMBITS:                    equ   dh
DUALADC_1_bCALCTIME:                   equ   1h
DUALADC_1_bMAXRES:                     equ   0Dh      ; Max resolution 13 bits
DUALADC_1_bMINRES:                     equ   07h      ; Min resolution 7 bits
DUALADC_1_fCOMPARE_TRUE:               equ   08h      ; Bit to enable compare True interrupts

; Functionality constants
DUALADC_1_fFSW0:                       equ   10h      ; Switch Cap FSW0 switch enable
DUALADC_1_NoAZ:                        equ   01h      ; Set if AutoZero is no enabled
DUALADC_1_fAutoZero:                   equ   20h      ; Switch Cap AutoZero switch enable
DUALADC_1_fDBLK_ENABLE:                equ   01h      ; Digital block enable bit
DUALADC_1_fPULSE_WIDE:                 equ   04h      ; Enable wide terminal count pulse.

; fStatus definitions
DUALADC_1_fDATA_READY:                 equ   10h      ; This bit is set when data is available
DUALADC_1_bRES_MASK:                   equ   0Fh      ; This bit while in integrate cycle

; Data Format
DUALADC_1_DATA_FORMAT:                 equ   0

; Flag in CR2 register mask
DUALADC_1_fRES_SET:                    equ   01h

;--------------------------------------------------
; Register Address Contants for DUALADC_1
;--------------------------------------------------

; TriADC PSoC Block register Definitions
; Integrator1 Block Register Definitions
DUALADC_1_bfADC1cr0:    equ 84h
DUALADC_1_bfADC1cr1:    equ 85h
DUALADC_1_bfADC1cr2:    equ 86h
DUALADC_1_bfADC1cr3:    equ 87h
; Integrator2 Block Register Definitions
DUALADC_1_bfADC2cr0:    equ 88h
DUALADC_1_bfADC2cr1:    equ 89h
DUALADC_1_bfADC2cr2:    equ 8ah
DUALADC_1_bfADC2cr3:    equ 8bh

; Counter1 Block Register Definitions
DUALADC_1_fCounter1FN:  equ 30h
DUALADC_1_fCounter1SL:  equ 31h
DUALADC_1_fCounter1OS:  equ 32h
DUALADC_1_bCount1:  equ 30h
DUALADC_1_bPeriod1: equ 31h
DUALADC_1_bCompare1:    equ 32h
DUALADC_1_bCounter1_CR0:    equ 33h

; Counter2 Block Register Definitions
DUALADC_1_fCounter2FN:  equ 3ch
DUALADC_1_fCounter2SL:  equ 3dh
DUALADC_1_fCounter2OS:  equ 3eh
DUALADC_1_bCount2:  equ 3ch
DUALADC_1_bPeriod2: equ 3dh
DUALADC_1_bCompare2:    equ 3eh
DUALADC_1_bCounter2_CR0:    equ 3fh


; PWM16 Block Register Definitions
DUALADC_1_bfPWM_LSB_FN: equ 34h
DUALADC_1_bfPWM_MSB_FN: equ 38h
DUALADC_1_fPWM_LSB_CR0: equ 37h
DUALADC_1_fPWM_MSB_CR0: equ 3bh
DUALADC_1_bPWM_Count_MSB:   equ 38h
DUALADC_1_bPWM_Count_LSB:   equ 34h
DUALADC_1_bPWM_Period_MSB:  equ 39h
DUALADC_1_bPWM_Period_LSB:  equ 35h
DUALADC_1_bPWM_IntTime_MSB: equ 3ah
DUALADC_1_bPWM_IntTime_LSB: equ 36h
DUALADC_1_bfPWM_LSB_FN: equ 34h
DUALADC_1_bfPWM_MSB_FN: equ 38h

; end of file DUALADC_1.inc

