;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: RTOS_Timer8.asm
;;   Version: 2.70, Updated on 2013/5/19 at 10:44:42
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION: Timer8 User Module software implementation file
;;
;;  NOTE: User Module APIs conform to the fastcall16 convention for marshalling
;;        arguments and observe the associated "Registers are volatile" policy.
;;        This means it is the caller's responsibility to preserve any values
;;        in the X and A registers that are still needed after the API functions
;;        returns. For Large Memory Model devices it is also the caller's 
;;        responsibility to perserve any value in the CUR_PP, IDX_PP, MVR_PP and 
;;        MVW_PP registers. Even though some of these registers may not be modified
;;        now, there is no guarantee that will remain the case in future releases.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "RTOS_Timer8.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  RTOS_Timer8_EnableInt
export _RTOS_Timer8_EnableInt
export  RTOS_Timer8_DisableInt
export _RTOS_Timer8_DisableInt
export  RTOS_Timer8_Start
export _RTOS_Timer8_Start
export  RTOS_Timer8_Stop
export _RTOS_Timer8_Stop
export  RTOS_Timer8_WritePeriod
export _RTOS_Timer8_WritePeriod
export  RTOS_Timer8_WriteCompareValue
export _RTOS_Timer8_WriteCompareValue
export  RTOS_Timer8_bReadCompareValue
export _RTOS_Timer8_bReadCompareValue
export  RTOS_Timer8_bReadTimer
export _RTOS_Timer8_bReadTimer
export  RTOS_Timer8_bReadTimerSaveCV
export _RTOS_Timer8_bReadTimerSaveCV

; The following functions are deprecated and subject to omission in future releases
;
export  bRTOS_Timer8_ReadCompareValue  ; deprecated
export _bRTOS_Timer8_ReadCompareValue  ; deprecated
export  bRTOS_Timer8_ReadTimer         ; deprecated
export _bRTOS_Timer8_ReadTimer         ; deprecated
export  bRTOS_Timer8_ReadTimerSaveCV   ; deprecated
export _bRTOS_Timer8_ReadTimerSaveCV   ; deprecated

export  bRTOS_Timer8_ReadCounter       ; obsolete
export _bRTOS_Timer8_ReadCounter       ; obsolete
export  bRTOS_Timer8_CaptureCounter    ; obsolete
export _bRTOS_Timer8_CaptureCounter    ; obsolete


AREA RTOS_PLANTILLA_FINAL_RAM (RAM,REL)

;-----------------------------------------------
;  Constant Definitions
;-----------------------------------------------


;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------


AREA UserModules (ROM, REL)

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_EnableInt
;
;  DESCRIPTION:
;     Enables this timer's interrupt by setting the interrupt enable mask bit
;     associated with this User Module. This function has no effect until and
;     unless the global interrupts are enabled (for example by using the
;     macro M8C_EnableGInt).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None.
;  RETURNS:      Nothing.
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 RTOS_Timer8_EnableInt:
_RTOS_Timer8_EnableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   RTOS_Timer8_EnableInt_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_DisableInt
;
;  DESCRIPTION:
;     Disables this timer's interrupt by clearing the interrupt enable
;     mask bit associated with this User Module.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 RTOS_Timer8_DisableInt:
_RTOS_Timer8_DisableInt:
   RAM_PROLOGUE RAM_USE_CLASS_1
   RTOS_Timer8_DisableInt_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_Start
;
;  DESCRIPTION:
;     Sets the start bit in the Control register of this user module.  The
;     timer will begin counting on the next input clock.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 RTOS_Timer8_Start:
_RTOS_Timer8_Start:
   RAM_PROLOGUE RAM_USE_CLASS_1
   RTOS_Timer8_Start_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_Stop
;
;  DESCRIPTION:
;     Disables timer operation by clearing the start bit in the Control
;     register.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 RTOS_Timer8_Stop:
_RTOS_Timer8_Stop:
   RAM_PROLOGUE RAM_USE_CLASS_1
   RTOS_Timer8_Stop_M
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_WritePeriod
;
;  DESCRIPTION:
;     Write the 8-bit period value into the Period register (DR1). If the
;     Timer user module is stopped, then this value will also be latched
;     into the Count register (DR0).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: fastcall16 BYTE bPeriodValue (passed in A)
;  RETURNS:   Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 RTOS_Timer8_WritePeriod:
_RTOS_Timer8_WritePeriod:
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   reg[RTOS_Timer8_PERIOD_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_WriteCompareValue
;
;  DESCRIPTION:
;     Writes compare value into the Compare register (DR2).
;
;     NOTE! The Timer user module must be STOPPED in order to write the
;           Compare register. (Call RTOS_Timer8_Stop to disable).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    fastcall16 BYTE bCompareValue (passed in A)
;  RETURNS:      Nothing
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 RTOS_Timer8_WriteCompareValue:
_RTOS_Timer8_WriteCompareValue:
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   reg[RTOS_Timer8_COMPARE_REG], A
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_bReadCompareValue
;
;  DESCRIPTION:
;     Reads the Compare register.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      fastcall16 BYTE bCompareValue (value of DR2 in the A register)
;  SIDE EFFECTS: 
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
 RTOS_Timer8_bReadCompareValue:
_RTOS_Timer8_bReadCompareValue:
 bRTOS_Timer8_ReadCompareValue:                  ; this name deprecated
_bRTOS_Timer8_ReadCompareValue:                  ; this name deprecated
   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   A, reg[RTOS_Timer8_COMPARE_REG]
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_bReadTimerSaveCV
;
;  DESCRIPTION:
;     Returns the value in the Count register (DR0), preserving the
;     value in the compare register (DR2).
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: None
;  RETURNS:   fastcall16 BYTE bCount (value of DR0 in the A register)
;  SIDE EFFECTS:
;     1) May cause an interrupt, if interrupt on Compare is enabled.
;     2) If enabled, Global interrupts are momentarily disabled.
;     3) The user module is stopped momentarily while the compare value is
;        restored.  This may cause the Count register to miss one or more
;        counts depending on the input clock speed.
;     4) The A and X registers may be modified by this or future implementations
;        of this function.  The same is true for all RAM page pointer registers in
;        the Large Memory Model.  When necessary, it is the calling function's
;        responsibility to perserve their values across calls to fastcall16 
;        functions.
;
;  THEORY of OPERATION:
;     1) Read and save the Compare register.
;     2) Read the Count register, causing its data to be latched into
;        the Compare register.
;     3) Read and save the Counter value, now in the Compare register,
;        to the buffer.
;     4) Disable global interrupts
;     5) Halt the timer
;     6) Restore the Compare register values
;     7) Start the Timer again
;     8) Restore global interrupt state
;
 RTOS_Timer8_bReadTimerSaveCV:
_RTOS_Timer8_bReadTimerSaveCV:
 bRTOS_Timer8_ReadTimerSaveCV:                   ; this name deprecated
_bRTOS_Timer8_ReadTimerSaveCV:                   ; this name deprecated
 bRTOS_Timer8_ReadCounter:                       ; this name deprecated
_bRTOS_Timer8_ReadCounter:                       ; this name deprecated

CpuFlags:      equ   0
bCount:        equ   1

   RAM_PROLOGUE RAM_USE_CLASS_2
   mov   X, SP                                   ; X <- stack frame pointer
   add   SP, 2                                   ; Reserve space for flags, count
   mov   A, reg[RTOS_Timer8_CONTROL_REG]         ; save the Control register
   push  A
   mov   A, reg[RTOS_Timer8_COMPARE_REG]         ; save the Compare register
   push  A
   mov   A, reg[RTOS_Timer8_COUNTER_REG]         ; synchronous copy DR2 <- DR0
                                                 ; This may cause an interrupt!
   mov   A, reg[RTOS_Timer8_COMPARE_REG]         ; Now grab DR2 (DR0) and save
   mov   [X+bCount], A
   mov   A, 0                                    ; Guess the global interrupt state
   tst   reg[CPU_F], FLAG_GLOBAL_IE              ; Currently Disabled?
   jz    .SetupStatusFlag                        ;   Yes, guess was correct
   mov   A, FLAG_GLOBAL_IE                       ;    No, modify our guess
.SetupStatusFlag:                                ; and ...
   mov   [X+CpuFlags], A                         ;   StackFrame[0] <- Flag Reg image
   M8C_DisableGInt                               ; Disable interrupts globally
   RTOS_Timer8_Stop_M                            ; Stop the timer
   pop   A                                       ; Restore the Compare register
   mov   reg[RTOS_Timer8_COMPARE_REG], A
   pop   A                                       ; restore start state of the timer
   mov   reg[RTOS_Timer8_CONTROL_REG], A
   pop   A                                       ; Return result stored in stack frame
   RAM_EPILOGUE RAM_USE_CLASS_2
   reti                                          ; Flag Reg <- StackFrame[0]

.ENDSECTION


.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: RTOS_Timer8_bReadTimer
;
;  DESCRIPTION:
;     Performs a software capture of the Count register.  A synchronous
;     read of the Count register is performed.  The timer is NOT stopped.
;
;     WARNING - this will cause loss of data in the Compare register.
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    None
;  RETURNS:      fastcall16 BYTE bCount, (value of DR0 in the A register)
;  SIDE EFFECTS:
;    May cause an interrupt.
;
;    The A and X registers may be modified by this or future implementations
;    of this function.  The same is true for all RAM page pointer registers in
;    the Large Memory Model.  When necessary, it is the calling function's
;    responsibility to perserve their values across calls to fastcall16 
;    functions.
;
;  THEORY of OPERATION:
;     1) Read the Count register - this causes the count value to be
;        latched into the Compare register.
;     2) Read and return the Count register values from the Compare
;        registers into the return buffer.
;
 RTOS_Timer8_bReadTimer:
_RTOS_Timer8_bReadTimer:
 bRTOS_Timer8_ReadTimer:                         ; this name deprecated
_bRTOS_Timer8_ReadTimer:                         ; this name deprecated
 bRTOS_Timer8_CaptureCounter:                    ; this name deprecated
_bRTOS_Timer8_CaptureCounter:                    ; this name deprecated

   RAM_PROLOGUE RAM_USE_CLASS_1
   mov   A, reg[RTOS_Timer8_COUNTER_REG]         ; synchronous copy DR2 <- DR0
                                                 ; This may cause an interrupt!
   mov   A, reg[RTOS_Timer8_COMPARE_REG]         ; Return DR2 (actually DR0)
   RAM_EPILOGUE RAM_USE_CLASS_1
   ret

.ENDSECTION

; End of File RTOS_Timer8.asm
