//*****************************************************************************
//*****************************************************************************
//  FILENAME: RTOS_Timer8.h
//   Version: 2.70, Updated on 2013/5/19 at 10:44:42
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION: Timer8 User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef RTOS_Timer8_INCLUDE
#define RTOS_Timer8_INCLUDE

#include <m8c.h>

#pragma fastcall16 RTOS_Timer8_EnableInt                 //                 Proxy 1
#pragma fastcall16 RTOS_Timer8_DisableInt                //                 Proxy 1
#pragma fastcall16 RTOS_Timer8_Start                     //                 Proxy 1
#pragma fastcall16 RTOS_Timer8_Stop                      //                 Proxy 1
#pragma fastcall16 RTOS_Timer8_bReadTimer                // Read  DR0       Proxy 1
#pragma fastcall16 RTOS_Timer8_bReadTimerSaveCV          // Read  DR0       Proxy 2
#pragma fastcall16 RTOS_Timer8_WritePeriod               // Write DR1       Proxy 1
#pragma fastcall16 RTOS_Timer8_bReadCompareValue         // Read  DR2       Proxy 1
#pragma fastcall16 RTOS_Timer8_WriteCompareValue         // Write DR2       Proxy 1

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bRTOS_Timer8_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 bRTOS_Timer8_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 bRTOS_Timer8_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 bRTOS_Timer8_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 bRTOS_Timer8_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the RTOS_Timer8 API.
//-------------------------------------------------

extern void RTOS_Timer8_EnableInt(void);
extern void RTOS_Timer8_DisableInt(void);
extern void RTOS_Timer8_Start(void);
extern void RTOS_Timer8_Stop(void);
extern BYTE RTOS_Timer8_bReadTimer(void);
extern BYTE RTOS_Timer8_bReadTimerSaveCV(void);
extern void RTOS_Timer8_WritePeriod(BYTE bPeriod);
extern BYTE RTOS_Timer8_bReadCompareValue(void);
extern void RTOS_Timer8_WriteCompareValue(BYTE bCompareValue);

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bRTOS_Timer8_ReadCompareValue(void);       // Deprecated
extern BYTE bRTOS_Timer8_ReadTimerSaveCV(void);        // Deprecated
extern BYTE bRTOS_Timer8_ReadCounter(void);            // Obsolete
extern BYTE bRTOS_Timer8_ReadTimer(void);              // Deprecated
extern BYTE bRTOS_Timer8_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for RTOS_Timer8 API's.
//--------------------------------------------------

#define RTOS_Timer8_CONTROL_REG_START_BIT      ( 0x01 )
#define RTOS_Timer8_INT_REG_ADDR               ( 0x0e1 )
#define RTOS_Timer8_INT_MASK                   ( 0x01 )


//--------------------------------------------------
// Constants for RTOS_Timer8 user defined values
//--------------------------------------------------

#define RTOS_Timer8_PERIOD                     ( 0x3e )
#define RTOS_Timer8_COMPARE_VALUE              ( 0x00 )


//-------------------------------------------------
// Register Addresses for RTOS_Timer8
//-------------------------------------------------

#pragma ioport  RTOS_Timer8_COUNTER_REG:    0x020          //DR0 Count register
BYTE            RTOS_Timer8_COUNTER_REG;
#pragma ioport  RTOS_Timer8_PERIOD_REG: 0x021              //DR1 Period register
BYTE            RTOS_Timer8_PERIOD_REG;
#pragma ioport  RTOS_Timer8_COMPARE_REG:    0x022          //DR2 Compare register
BYTE            RTOS_Timer8_COMPARE_REG;
#pragma ioport  RTOS_Timer8_CONTROL_REG:    0x023          //Control register
BYTE            RTOS_Timer8_CONTROL_REG;
#pragma ioport  RTOS_Timer8_FUNC_REG:   0x120              //Function register
BYTE            RTOS_Timer8_FUNC_REG;
#pragma ioport  RTOS_Timer8_INPUT_REG:  0x121              //Input register
BYTE            RTOS_Timer8_INPUT_REG;
#pragma ioport  RTOS_Timer8_OUTPUT_REG: 0x122              //Output register
BYTE            RTOS_Timer8_OUTPUT_REG;
#pragma ioport  RTOS_Timer8_INT_REG:       0x0e1           //Interrupt Mask Register
BYTE            RTOS_Timer8_INT_REG;


//-------------------------------------------------
// RTOS_Timer8 Macro 'Functions'
//-------------------------------------------------

#define RTOS_Timer8_Start_M \
   ( RTOS_Timer8_CONTROL_REG |=  RTOS_Timer8_CONTROL_REG_START_BIT )

#define RTOS_Timer8_Stop_M  \
   ( RTOS_Timer8_CONTROL_REG &= ~RTOS_Timer8_CONTROL_REG_START_BIT )

#define RTOS_Timer8_EnableInt_M   \
   M8C_EnableIntMask(  RTOS_Timer8_INT_REG, RTOS_Timer8_INT_MASK )

#define RTOS_Timer8_DisableInt_M  \
   M8C_DisableIntMask( RTOS_Timer8_INT_REG, RTOS_Timer8_INT_MASK )

#endif
// end of file RTOS_Timer8.h
