;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: RTOS_Timer8.inc
;;   Version: 2.70, Updated on 2013/5/19 at 10:44:42
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION: Assembler declarations for the Timer8 user module interface
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for RTOS_Timer8 API's.
;--------------------------------------------------

RTOS_Timer8_CONTROL_REG_START_BIT:         equ 0x01    ; Control register start bit
RTOS_Timer8_INT_REG:                       equ 0x0e1
RTOS_Timer8_INT_MASK:                      equ 0x01


;--------------------------------------------------
; Constants for RTOS_Timer8 user defined values
;--------------------------------------------------

RTOS_Timer8_PERIOD:                        equ 0x3e
RTOS_Timer8_COMPARE_VALUE:                 equ 0x00


;--------------------------------------------------
; Register Address Constants for RTOS_Timer8
;--------------------------------------------------

RTOS_Timer8_COUNTER_REG:               equ 0x20   ; DR0 Counter register
RTOS_Timer8_PERIOD_REG:                equ 0x21   ; DR1 Period register
RTOS_Timer8_COMPARE_REG:               equ 0x22   ; DR2 CompareValue register
RTOS_Timer8_CONTROL_REG:               equ 0x23   ; Control register
RTOS_Timer8_FUNC_REG:                  equ 0x20   ; Function register
RTOS_Timer8_INPUT_REG:                 equ 0x21   ; Input register
RTOS_Timer8_OUTPUT_REG:                equ 0x22   ; Output register


;--------------------------------------------------
; RTOS_Timer8 Macro 'Functions'
;--------------------------------------------------

   macro RTOS_Timer8_Start_M
   or    reg[RTOS_Timer8_CONTROL_REG],  RTOS_Timer8_CONTROL_REG_START_BIT
   endm

   macro RTOS_Timer8_Stop_M
   and   reg[RTOS_Timer8_CONTROL_REG], ~RTOS_Timer8_CONTROL_REG_START_BIT
   endm

   macro RTOS_Timer8_EnableInt_M
   M8C_EnableIntMask RTOS_Timer8_INT_REG, RTOS_Timer8_INT_MASK
   endm

   macro RTOS_Timer8_DisableInt_M
   M8C_DisableIntMask RTOS_Timer8_INT_REG, RTOS_Timer8_INT_MASK
   endm


; end of file RTOS_Timer8.inc
